<?php

// +---------------------------------------------------------------------------+
// | phpblock_myminicity.php for Geeklog 1.4.1                                 |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2008 dengen - taharaxp AT gmail DOT com                     |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//
// $Id$

/**
* MyMiniCity View Function for Geeklog Ver 1.1.3 2008/01/20
*
* @authors dengen (Yoshinori Tahara) - taharaxp AT gmail DOT com
*
* @caution 1. このスクリプトはUTF-8で書かれています。EUC-JPで使う場合は，EUC-JP
*            で保存し直してください。
*
* 私の街にも遊びに来てくださいね^^
* http://dengen.myminicity.com/
*
*/

//-------------------------------------
//  Configurations
//-------------------------------------

// あなたのユーザ名を設定してください。
$myminicity_username = 'username';

// 表示幅を設定してください。
$myminicity_width = 180;

// 訪問者を誘うコメントを設定してください。（日本語）
$myminicity_message_jp = 'Please visit MyMiniCity!';

// 訪問者を誘うコメントを設定してください。（英語）
$myminicity_message_en = 'Please visit MyMiniCity!';

// ステータスを表示するかどうか。(する:true, しない:false)
$myminicity_show_status = true;

//-------------------------------------

// XHTML化
if (!defined ('XHTML')) {
    define('XHTML',''); // change this to ' /' for XHTML
}

// Language definition
if (empty($_USER['language'])) {
    if (empty($_COOKIE[$_CONF['cookie_language']])) {
        $MMCITY_LANG = 'english_utf-8';
    } else {
        $MMCITY_LANG = $_COOKIE[$_CONF['cookie_language']];
    }
} else {
    $MMCITY_LANG = $_USER['language'];
}

// Language data for Japanese(utf-8)
$LANG_MYMINICITY['japanese_utf-8'] = array(
    'status'          => '::&nbsp;ステータス&nbsp;::',
    'region'          => '国　名',
    'ranking'         => '順　位',
    'population'      => '人　口',
    'incomes'         => '税　収',
    'unemployment'    => '失業率',
    'transport'       => '輸送率',
    'criminality'     => '犯罪発生率',
    'pollution'       => '環境汚染率',
    'unit_ranking'    => '位',
    'unit_population' => '人',
    'inc_population'  => '人口を増やす',
    'inc_industry'    => '産業を発展させる',
    'imp_transport'   => '交通網を整備する',
    'inc_security'    => '治安を良くする',
    'imp_environment' => '環境を整備する',
    'inc_business'    => '商業を発展させる',
    'message'         => $myminicity_message_jp
);

// Language data for English(utf-8)
$LANG_MYMINICITY['english_utf-8'] = array(
    'status'          => '::&nbsp;STATUS&nbsp;::',
    'region'          => 'Region',
    'ranking'         => 'Ranking',
    'population'      => 'Population',
    'incomes'         => 'Incomes',
    'unemployment'    => 'Unemployment',
    'transport'       => 'Transport',
    'criminality'     => 'Criminality',
    'pollution'       => 'Pollution',
    'unit_ranking'    => '',
    'unit_population' => '',
    'inc_population'  => 'Increase population',
    'inc_industry'    => 'Increase industry',
    'imp_transport'   => 'Improve transport',
    'inc_security'    => 'Increase security',
    'imp_environment' => 'Improve environment',
    'inc_business'    => 'Increase business',
    'message'         => $myminicity_message_en
);

// The name of data file
define('DATA_FILE', $_CONF['path_data'] . 'phpblock_myminicity.dat');


//-------------------------------------
//  Functions
//-------------------------------------

require_once 'HTTP/Request.php';

function phpblock_myminicity()
{
    global $_CONF, $LANG_CHARSET, $myminicity_username,
           $myminicity_width, $myminicity_show_status,
           $LANG_MYMINICITY, $MMCITY_LANG;

    $height = intval($myminicity_width * 2 / 3); // W : H = 6 : 4

    $url = 'http://' . $myminicity_username . '.myminicity.com/';
    $xml = $url . 'xml';
    $items = array();
    
// 一応コードは残しておく
/*
    $reader = new XMLReader();
    $reader->open($xml);
    $dom = new DomDocument("1.0", "UTF-8");
    while ($reader->read()) {
        switch ($reader->nodeType) {
        case (XMLREADER::ELEMENT):
            switch( $reader->localName ){
            case "city":
                $node = $reader->expand();
                $n = $dom->importNode($node,true);
                $sxml = simplexml_import_dom($n);
                foreach($sxml as $a => $b) {
                    switch($a) {
                    case "bases":
                        $items['bases'] = array();
                        foreach($sxml->bases->attributes() as $a => $b) {
                            $items['bases'][$a] = $b;
                        }
                        break;
                        
                    default:
                        $items[$a] = $b;
                        break;
                    }
                }
                break;
                
            default:
                break;
            }
            break;
            
        default:
            break;
        }
    }
    $reader->close;
    
*/

    // Get params from XML feed
    $req =& new HTTP_Request($xml); // オブジェクト生成
    $req->sendRequest();
    if ($req->getResponseCode() == 200) {
        $temp = $req->getResponseBody();
        if (preg_match('|<region code="\w+">(\w+)</region>\s*<ranking>(\d+)</ranking>\s*'
                     . '<population>(\d+)</population>\s*<incomes>(\d+)</incomes>\s*'
                     . '<unemployment>(\d+)</unemployment>\s*<transport>(\d+)</transport>\s*'
                     . '<criminality>(\d+)</criminality>\s*<pollution>(\d+)</pollution>\s*'
                     . '<nextnuke>\d+</nextnuke>\s*<signatures>\d+</signatures>\s*'
                     . '<bases com="(\d+)" env="(\d+)" ind="(\d+)" sec="(\d+)" tra="(\d+)"/>|mi', $temp, $M)) {

            $items['region']       = $M[1];
            $items['ranking']      = $M[2];
            $items['population']   = $M[3];
            $items['incomes']      = $M[4];
            $items['unemployment'] = $M[5];
            $items['transport']    = $M[6];
            $items['criminality']  = $M[7];
            $items['pollution']    = $M[8];
            $items['bases'] = array();
            $items['bases']['com'] = $M[9];
            $items['bases']['env'] = $M[10];
            $items['bases']['ind'] = $M[11];
            $items['bases']['sec'] = $M[12];
            $items['bases']['tra'] = $M[13];
            
        }
    }
    
    $addpath = MYMINICITY_addPath($items);
    $url = $url . $addpath; // ステータスの値に応じてパスを変更する
    $message = htmlspecialchars($LANG_MYMINICITY[$MMCITY_LANG]['message'], ENT_QUOTES, $LANG_CHARSET);
    switch ($addpath) {     // ステータスの値に応じてメッセージを変更する
    case "ind":
        $message2 = $LANG_MYMINICITY[$MMCITY_LANG]['inc_industry'];
        break;
    case "tra":
        $message2 = $LANG_MYMINICITY[$MMCITY_LANG]['imp_transport'];
        break;
    case "sec":
        $message2 = $LANG_MYMINICITY[$MMCITY_LANG]['inc_security'];
        break;
    case "env":
        $message2 = $LANG_MYMINICITY[$MMCITY_LANG]['imp_environment'];
        break;
    case "com":
        $message2 = $LANG_MYMINICITY[$MMCITY_LANG]['inc_business'];
        break;
    default:
        $message2 = $LANG_MYMINICITY[$MMCITY_LANG]['inc_population'];
        break;
    }
    $message .= '<br' . XHTML . '>[' . $message2 . ']';

    if ( file_exists( DATA_FILE ) ) {
        $vars = MYMINICITY_readParam();
        $v = str_replace ( '&', ',', $vars );
        $v = str_replace ( '=', ',', $v );
        $a = explode(',', $v);
        if ( ($a[3] == $items['population']) &&
             ($a[5] == $items['bases']['ind']) &&
             ($a[7] == $items['bases']['tra']) &&
             ($a[9] == $items['bases']['sec']) &&
             ($a[11] == $items['bases']['env']) &&
             ($a[13] == $items['bases']['com']) ) {
            $param = $vars;
        } else {
            $param = MYMINICITY_getParam($url);
        }
    } else {
        $param = MYMINICITY_getParam($url);
    }
    
    $param = str_replace ( '&', '&amp;', $param );
    $display = '<div id="myminicity">' . LB
             . '  <object id="client" name="client" type="application/x-shockwave-flash" '
             . 'style="background-color: #deecfe;" '
             . 'width="' . $myminicity_width . '" height="' . $height . '" '
             . 'data="http://data.myminicity.com/swf/client.swf?v=0">' . LB
             . '    <param name="movie" value="http://data.myminicity.com/swf/client.swf?v=0"' . XHTML . '>' . LB
             . '    <param name="flashvars" value="' . $param . '"' . XHTML . '>' . LB
             . '    <param name="allowscriptaccess" value="always"' . XHTML . '>' . LB
             . '    <param name="menu" value="false"' . XHTML . '>' . LB
             . '    <param name="quality" value="high"' . XHTML . '>' . LB
             . '  </object>' . LB
             . '  <p class="message"><a href="' . $url . '">'
             . $message
             . '</a></p>' . LB;
    if ($myminicity_show_status) {  // ステータスの表示
        $display .= '  <table class="status" summary="status of my mini city">' . LB
             . '    <caption>' . $LANG_MYMINICITY[$MMCITY_LANG]['status'] . '</caption>' . LB

             . '    <tr class="region"><th class="name">'
             . $LANG_MYMINICITY[$MMCITY_LANG]['region']
             . '</th><td class="value">'
             . strtoupper($items['region']) . '</td></tr>' . LB

             . '    <tr class="ranking"><th class="name">'
             . $LANG_MYMINICITY[$MMCITY_LANG]['ranking']
             . '</th><td class="value">'
             . $items['ranking'] . '&nbsp;' . $LANG_MYMINICITY[$MMCITY_LANG]['unit_ranking'] .'</td></tr>' . LB

             . '    <tr class="population"><th class="name">'
             . $LANG_MYMINICITY[$MMCITY_LANG]['population']
             . '</th><td class="value">'
             . $items['population'] . '&nbsp;' . $LANG_MYMINICITY[$MMCITY_LANG]['unit_population'] . '</td></tr>' . LB

             . '    <tr class="incomes"><th class="name">'
             . $LANG_MYMINICITY[$MMCITY_LANG]['incomes']
             . '</th><td class="value">'
             . $items['incomes'] . '&nbsp;&euro;</td></tr>' . LB

             . '    <tr class="unemployment"><th class="name">'
             . $LANG_MYMINICITY[$MMCITY_LANG]['unemployment']
             . '</th><td class="value">'
             . $items['unemployment'] . '&nbsp;%</td></tr>' . LB

             . '    <tr class="transport"><th class="name">'
             . $LANG_MYMINICITY[$MMCITY_LANG]['transport']
             . '</th><td class="value">'
             . $items['transport'] . '&nbsp;%</td></tr>' . LB

             . '    <tr class="criminality"><th class="name">'
             . $LANG_MYMINICITY[$MMCITY_LANG]['criminality']
             . '</th><td class="value">'
             . $items['criminality'] . '&nbsp;%</td></tr>' . LB

             . '    <tr class="pollution"><th class="name">'
             . $LANG_MYMINICITY[$MMCITY_LANG]['pollution']
             . '</th><td class="value">'
             . $items['pollution'] . '&nbsp;%</td></tr>' . LB

             . '  </table>'. LB
             . '</div>'. LB;
    }
    return $display;
}

// HTTPリクエストでMyMiniCityサイトを取得し、パラメータを取得する
function MYMINICITY_getParam ($url)
{
    global $myminicity_username;

//    require_once 'HTTP/Request.php';

    $ua = $_SERVER['HTTP_USER_AGENT'];

//  $referrer はどっちが適正なんだろう？
    $referrer = COM_getCurrentURL();
//  $referrer = $_SERVER['HTTP_REFERER'];

    // 固定する必要がある
    // http://username.myminicity.com/ind などとすると,結局途中で
    // http://username.myminicity.com/ にリダイレクトされてうまく
    // 情報が取得できないようだ
    $url = 'http://' . $myminicity_username . '.myminicity.com/';

    //オブジェクト生成
    $req =& new HTTP_Request($url);

    //UA
    $req->addHeader('User-Agent', $ua);

    //リクエストメソッド
    $req->setMethod(HTTP_REQUEST_METHOD_GET);

    //クッキー
    $req->addCookie("X-MV-referrer", $referrer);
    // $urlを固定したため、人口ばかり増えることになるので、
    // クッキーは設定しない。
    // と、思ったら、このクッキーがないとうまく情報を取得できないことが
    // 判明したので、もとに戻す^^;
    // 人口ばかり増え続けないかなー^^;
    $req->addCookie("X-Ref-Ok", "1");

    //リクエスト送信
    $req->sendRequest();

    //レスポンス取得
    $res = $req->getResponseBody();

    if ( preg_match( '/"(name=.*?&k=.*?)"/', $res, $match ) ) {
        $param = $match[1];
        MYMINICITY_writeParam($param);
    } else {
        $param = MYMINICITY_readParam();
    }

    return $param;
}

// キャッシュデータを保存する
function MYMINICITY_writeParam ($str)
{
    $fp = @fopen( DATA_FILE, 'w' );
    if ( $fp ) {
        $len = strlen( $str );
        @flock( $fp, LOCK_EX );
        @fwrite( $fp, $str, $len );
        @flock( $fp, LOCK_UN );
        @fclose( $fp );
        return true;
    } else {
        COM_errorLog( "Cannot open " . DATA_FILE . " for writing.", 1 );
    }
}

// キャッシュデータを読み込む
function MYMINICITY_readParam ()
{
    $fp = @fopen( DATA_FILE, 'r' );
    if ( $fp ) {
        $str = @fgets( $fp );
        @fclose( $fp );
        return $str;
    } else {
        COM_errorLog( "Cannot open " . DATA_FILE . " for reading.", 1 );
    }
}

// 失業率が増える   → 工場を作る     ind
// 交通渋滞が起こる → 交通を整備する tra
// 犯罪が増える     → 警官を配備する sec
// 汚染が拡大する   → 公園を作る     env
function MYMINICITY_addPath ($items)
{
    $path = array(
        'ind' => $items['unemployment'],
        'tra' => 100 - $items['transport'],
        'sec' => $items['criminality'],
        'env' => $items['pollution'],
    );
    $p = '';
    $v = 0;
    foreach($path as $a => $b) {
        if ($v < (int)$b) {
            $p = $a;
            $v = $b;
        }
    }
    return $p;
}

?>
